Build project
-------------

```
$ mvn clean package
```

Following artifacts are produceed:

- module_ejb_interface/target/ejb-1.0-SNAPSHOT.jar
    contains remote ejb interface. 
    
- module_wildfly/target/wildfly_app.war
    ejb containing app to be deployed into Wildfly instance.
    
- module_was/target/was_app.war
    frontend app with caller ejb that starts a new trasaction. Has to be deployed into Websphere.
    
    
Run dockerized WAS and deploy in it
-----------------------------------

Use official IBM Websphere image ( https://hub.docker.com/r/ibmcom/websphere-traditional/ ).


1) Start WAS v.9:
```
$ docker run -d --name was90 -h was90 \
  --add-host wildfly10:<replace_with_wildlfy_instance_ip> \
  -e UPDATE_HOSTNAME=true -p 9043:9043 -p 9443:9443 -p 9100:9100 \
  -v $(pwd)/module_was/target/:/tmp/target/ \
  ibmcom/websphere-traditional:9.0.0.2-profile
```

2) Obtain admin credentials:
```
$ echo "* Websphere admin credentials"; \
  echo " admin user: wsadmin"; \
  password=$(docker exec was90 cat /tmp/PASSWORD); \
  echo " admin pwd: $password"
```

3) Access admin console: 
    https://localhost:9043/ibm/console

4) Use admin console to deploy 'module_was/target/was_app.war' application

