package com.example.test.bean;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.lang.reflect.Method;
import java.net.Socket;
import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.annotation.Resource;
import javax.ejb.EJB;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.enterprise.context.Dependent;
import javax.enterprise.inject.Model;
import javax.inject.Inject;
import javax.inject.Named;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.rmi.PortableRemoteObject;
import javax.transaction.TransactionManager;

import com.example.test.bean.remote.ISampleEjb21;
import com.example.test.bean.remote.ISampleEjbHome21;

/**
 * 
 *
 */
@Stateless
public class SimpleBean {
	
	@TransactionAttribute(TransactionAttributeType.REQUIRED)
	@SuppressWarnings({ "rawtypes", "unchecked" })
	public String echoFromRemoteEjb() {
        Hashtable jndiProperties = new Hashtable();
        
		jndiProperties.put("java.naming.factory.initial", "com.ibm.websphere.naming.WsnInitialContextFactory");
		jndiProperties.put("java.naming.provider.url", "corbaloc::wildfly10:3528");
        
		try {
		    Context context = new InitialContext(jndiProperties);
		        
		    String jndi = "ejbtest/SampleEjb21";
		    System.out.println("lookin up jndi ["+jndi+"]");
			Object obj = context.lookup(jndi);
			System.out.println("lookup obj ["+obj.getClass()+"] ["+obj.toString()+"]");
			
			if ( obj instanceof ISampleEjbHome21 ) 
				System.out.println("obj match interface "+ISampleEjbHome21.class.toGenericString());
			else
				System.err.println(obj.getClass()+" does not match "+ISampleEjbHome21.class.toGenericString());
			ISampleEjbHome21 home = (ISampleEjbHome21) obj;
			
			System.out.println("creating Home interface ...");
			ISampleEjb21 sample = home.create();
			
			String echoResp = sample.echo();
			return echoResp;
		} catch(Exception ex) {
			ex.printStackTrace();
			return null;
		}
    }
}
